>From bf8ae3b403e6fd78094d2dd99db65f520a78e245 Mon Sep 17 00:00:00 2001
From: Joshua Ashton <joshua@froggi.es>
Date: Sun, 20 Jan 2019 11:50:32 +0000
Subject: [PATCH] d3d9: Make IDirect3D9Ex::GetAdapterDisplayModeEx PURE and add
 missing defines.

The GetAdapterDisplayModeEx method on IDirect3D9Ex was not marked as PURE.
This causes compilation errors for some d3d9 dlls/wrappers when being built against winelib.

There were also some missing defines which I have included in this commit.

Signed-off-by: Joshua Ashton <joshua@froggi.es>
---
 include/d3d9.h      | 4 +++-
 include/d3d9types.h | 3 +++
 2 files changed, 6 insertions(+), 1 deletion(-)

diff --git a/include/d3d9.h b/include/d3d9.h
index 08f4555913..04bb999fb7 100644
--- a/include/d3d9.h
+++ b/include/d3d9.h
@@ -65,8 +65,10 @@
 #define D3DPRESENT_DONOTWAIT                    __MSABI_LONG(1)
 #define D3DPRESENT_LINEAR_CONTENT               __MSABI_LONG(2)
 #define D3DPRESENT_BACK_BUFFERS_MAX             __MSABI_LONG(3)
+#define D3DPRESENT_BACK_BUFFERS_MAX_EX          __MSABI_LONG(30)
 #define D3DSGR_NO_CALIBRATION                   __MSABI_LONG(0x00000000)
 #define D3DSGR_CALIBRATE                        __MSABI_LONG(0x00000001)
+#define D3DCURSOR_IMMEDIATE_UPDATE              __MSABI_LONG(0x00000001)
 
 #define _FACD3D  0x876
 #define MAKE_D3DHRESULT( code )                 MAKE_HRESULT( 1, _FACD3D, code )
@@ -1617,7 +1619,7 @@ DECLARE_INTERFACE_(IDirect3D9Ex, IDirect3D9)
     STDMETHOD_(UINT, GetAdapterModeCountEx)(THIS_ UINT adapter_idx, const D3DDISPLAYMODEFILTER *filter) PURE;
     STDMETHOD(EnumAdapterModesEx)(THIS_ UINT adapter_idx, const D3DDISPLAYMODEFILTER *filter,
             UINT mode_idx, D3DDISPLAYMODEEX *mode) PURE;
-    STDMETHOD(GetAdapterDisplayModeEx)(THIS_ UINT adapter_idx, D3DDISPLAYMODEEX *mode, D3DDISPLAYROTATION *rotation);
+    STDMETHOD(GetAdapterDisplayModeEx)(THIS_ UINT adapter_idx, D3DDISPLAYMODEEX *mode, D3DDISPLAYROTATION *rotation) PURE;
     STDMETHOD(CreateDeviceEx)(THIS_ UINT adapter_idx, D3DDEVTYPE device_type, HWND focus_window, DWORD flags,
             D3DPRESENT_PARAMETERS *parameters, D3DDISPLAYMODEEX *mode, struct IDirect3DDevice9Ex **device) PURE;
     STDMETHOD(GetAdapterLUID)(THIS_ UINT adapter_idx, LUID *luid) PURE;
diff --git a/include/d3d9types.h b/include/d3d9types.h
index 4891858b3d..4166f435be 100644
--- a/include/d3d9types.h
+++ b/include/d3d9types.h
@@ -475,6 +475,9 @@ typedef enum _D3DSHADER_INSTRUCTION_OPCODE_TYPE {
 /** for parallelism */
 #define D3DSI_COISSUE 0x40000000
 
+#define D3DSP_OPCODESPECIFICCONTROL_MASK  0x00ff0000
+#define D3DSP_OPCODESPECIFICCONTROL_SHIFT 16
+
 #define D3DSP_DCL_USAGE_SHIFT 0
 #define D3DSP_DCL_USAGE_MASK  0x0000000f
 
-- 
2.20.1

